﻿using System;
using System.Collections.Generic;
using HeuristicLab.Services.Authentication.DataTransfer;
using System.ServiceModel;
using System.Net.Security;

namespace HeuristicLab.Services.Authentication
{
    [ServiceContract(ProtectionLevel = ProtectionLevel.EncryptAndSign)]
    public interface IAuthenticationService
    {
        #region User

        [OperationContract]
        User GetUser(Guid id);

      
        [OperationContract]
        IEnumerable<User> GetUsers(Guid applicationId);

        [OperationContract]
        bool InsertUser(User user);

        [OperationContract]
        bool DeleteUser(Guid id);

        [OperationContract]
        bool UpdateUser(User user);

        [OperationContract]
        bool AddUserToRole(Guid roleId, Guid userId);

        [OperationContract]
        bool RemoveUserFromRole(Guid roleId, Guid userId);

        [OperationContract]
        IEnumerable<Role> GetRolesForUser(Guid userId);

        #endregion

        #region Role

        [OperationContract]
        Role GetRole(Guid id);

     

        [OperationContract]
        IEnumerable<Role> GetRoles(Guid applicationId);

        [OperationContract]
        bool InsertRole(Role role);

        [OperationContract]
        bool UpdateRole(Role role);

        [OperationContract]
        bool DeleteRole(Guid id);

        [OperationContract]
        IEnumerable<User> GetUsersInRole(Guid roleId);

        #endregion

        #region Application

        [OperationContract]
        Application GetApplication(Guid id);

        [OperationContract]
        bool InsertApplication(Application application);

        [OperationContract]
        bool DeleteApplication(Guid id);

        [OperationContract]
        IEnumerable<DataTransfer.Application> GetApplications();

        #endregion

        
    }
}
